//package com.purui.ghip.filter;
//
//import com.purui.ghip.config.RateLimitConfig;
//import com.purui.ghip.utils.RedisUtil;
//
//import org.springframework.cloud.gateway.filter.GatewayFilter;
//import org.springframework.cloud.gateway.filter.factory.AbstractGatewayFilterFactory;
//import org.springframework.core.io.buffer.DataBuffer;
//import org.springframework.http.HttpStatus;
//import org.springframework.http.server.reactive.ServerHttpResponse;
//import org.springframework.stereotype.Component;
//import reactor.core.publisher.Mono;
//
//import java.nio.charset.StandardCharsets;
//import java.util.concurrent.TimeUnit;
//
///**
// * 限流
// *
// * @author charlie
// * @date 2024/9/9
// */
//@Component
//public class RateLimitFilter extends AbstractGatewayFilterFactory<RateLimitConfig> {
//
//	private final RedisUtil redisUtil;
//
//	public RateLimitFilter(RedisUtil redisUtil) {
//		super(RateLimitConfig.class);
//		this.redisUtil = redisUtil;
//	}
//
//	@Override
//	public GatewayFilter apply(RateLimitConfig config) {
//		return (exchange, chain) -> {
//			String ip = exchange.getRequest().getRemoteAddress().getAddress().getHostAddress();
//			String key = "rate_limit:" + ip;
//
//			// 获取当前 IP 的请求次数
//			Long count = redisUtil.increment(key, 1);
//
//			// 如果是第一次请求，设置过期时间
//			if (count == 1) {
//				redisUtil.expire(key, config.getInterval(), TimeUnit.SECONDS);
//			}
//
//			// 判断是否超过限流阈值
//			if (count > config.getLimit()) {
//				ServerHttpResponse response = exchange.getResponse();
//				response.setStatusCode(HttpStatus.TOO_MANY_REQUESTS);
//				DataBuffer buffer = response.bufferFactory().wrap("请求太频繁，请稍后再试".getBytes(StandardCharsets.UTF_8));
//				return response.writeWith(Mono.just(buffer));
//			}
//
//			return chain.filter(exchange);
//		};
//	}
//
//}