package com.purui.ghip.service;

import com.purui.ghip.model.MapInterface;
import com.purui.ghip.model.ResultSet;
import com.purui.ghip.model.XYSHisPlatformMaintain;
import com.purui.ghip.utils.RedisUtil;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;
import org.springframework.web.reactive.function.BodyInserters;
import org.springframework.web.reactive.function.client.WebClient;

import java.util.List;

@Component
public class ScheduledService {
	private  final RedisUtil redisUtil;

	public ScheduledService(RedisUtil redisUtil) {
		this.redisUtil = redisUtil;
	}

	@Scheduled(cron = "0/10 * * * * * ")
	public void XYSHisPlatformMaintainScheduled(){
		String params="{\"params\":[{}],\"code\":\"012\",\"session\":[{}]}";
		ResultSet rulesResult = WebClient.create()
				.post()
				.uri("http://172.16.2.6:52773/External/hipExternalMutiple")
				.header("Authorization", "Basic cHJoaXA6cHJoaXBAMjAyMA==")
				.body(BodyInserters.fromObject(params))
				.retrieve()
				.bodyToMono(ResultSet.class)
				.block();
		String errorCode=rulesResult.getErrorCode();
		if ((errorCode!="0")||(errorCode==null)){
			return ;
		}
		List<XYSHisPlatformMaintain> XYSHisPlatformMaintainArr= (List<XYSHisPlatformMaintain>) rulesResult.getResult();
		for (XYSHisPlatformMaintain xysHisPlatformMaintain : XYSHisPlatformMaintainArr) {
			String curHospCode=xysHisPlatformMaintain.getHospCode();
			String curCheckKye="XYSHisPlatformMaintain:"+curHospCode;
			redisUtil.set(curCheckKye,xysHisPlatformMaintain.toString());
		}
	}

	@Scheduled(cron = "0/10 * * * * * ")
	public void MapInterfaceScheduled(){
		String params="{\"params\":[{\"FindFieldVal\":{}}],\"code\":\"4003\",\"session\":[{}]}";
		ResultSet interfaceResult = WebClient.create()
				.post()
				.uri("http://172.16.2.6:52773/External/hipExternalMutiple")
				.header("Authorization", "Basic cHJoaXA6cHJoaXBAMjAyMA==")
				.body(BodyInserters.fromObject(params))
				.retrieve()
				.bodyToMono(ResultSet.class)
				.block();
		String errorCode=interfaceResult.getErrorCode();
		if ((errorCode!="0")||(errorCode==null)){
			return ;
		}
		List<MapInterface> mapInterfaceArr= (List<MapInterface>) interfaceResult.getData();
		for (MapInterface mapInterface : mapInterfaceArr) {
			String code=mapInterface.getCode();
			String curCheckKye="MapInterface:"+code;
			redisUtil.set(curCheckKye,mapInterface.toString());
		}
	}
}
